%define pkgname Mail-SpamAssassin

Name: spamassassin
Version: 3.4.2
Release: 1%{?dist}
Summary: Spam filter for email which can be invoked from mail delivery agents
License: Apache
Group: Applications/Internet
URL: http://spamassassin.apache.org/
Source0: http://www.apache.org/dist/spamassassin/source/Mail-SpamAssassin-%{version}.tar.bz2
Source1: http://www.apache.org/dist/spamassassin/source/Mail-SpamAssassin-rules-%{version}.r1840640.tgz
Source2: redhat_local3.cf
Source3: spamassassin-default.rc
Source4: spamassassin-spamc.rc
Source5: spamassassin.sysconfig
Source6: sa-update.logrotate
Source88: sa-update.cron.in
Source89: gpgkeys
Source90: channels
Source10: spamassassin-helper.sh
Source20: http://www.timj.co.uk/linux/bogus-virus-warnings.cf
#Source30: http://saupdates.openprotect.com/pub.gpg
Source40: http://spamassassin.apache.org/updates/GPG.KEY
Source50: http://www.apache.org/dist/spamassassin/KEYS
#Source60: http://yerp.org/rules/GPG.KEY
Source60: GPG-sought.KEY
Patch0: Mail-SpamAssassin-3.0.0-krb5.patch
Buildroot: %{_tmppath}/%{name}-root
Requires(pre): /sbin/chkconfig /sbin/service

BuildRequires: openssl-devel, krb5-devel
BuildRequires: autoconf
BuildRequires: perl >= 2:5.8.1
#
BuildRequires: perl(Digest::SHA)
BuildRequires: perl(File::Spec) >= 0.8
BuildRequires: perl(File::Copy) >= 2.02
BuildRequires: perl(Pod::Usage) >= 1.10
BuildRequires: perl(HTML::Parser) >= 3.43
BuildRequires: perl(Archive::Tar) >= 1.23
BuildRequires: perl(Mail::DKIM) >= 0.37
BuildRequires: perl(Net::DNS) >= 0.58
BuildRequires: perl(NetAddr::IP) >= 4.010
BuildRequires: perl(Sys::Hostname)
BuildRequires: perl(Time::HiRes)
BuildRequires: perl(Time::Local)
BuildRequires: perl(Errno)
#
BuildRequires: perl(MIME::Base64)
BuildRequires: perl(DB_File)
BuildRequires: perl(Net::SMTP)
BuildRequires: perl(Mail::SPF)
BuildRequires: perl(IP::Country::Fast)
BuildRequires: perl(Razor2::Client::Version) >= 2.61
BuildRequires: perl(Net::Ident)
BuildRequires: perl(IO::Socket::INET6)
BuildRequires: perl(IO::Socket::SSL)
BuildRequires: perl(Compress::Zlib)
BuildRequires: perl(DBI)
#BuildRequires: perl(DBD::...)
BuildRequires: perl(Getopt::Long) >= 2.34
BuildRequires: perl(LWP), perl(LWP::UserAgent)
BuildRequires: perl(HTTP::Date)
BuildRequires: perl(IO::Zlib) >= 1.04
BuildRequires: perl(Encode::Detect)
#
BuildRequires: perl(Apache::Test)
BuildRequires: mod_perl

BuildRequires: %{_bindir}/dccproc
BuildRequires: %{_bindir}/pyzor

##JPP
BuildRequires: perl(Net::DNS::Nameserver)

###
Requires: perl(Digest::SHA)
Requires: perl(File::Spec) >= 0.8
Requires: perl(File::Copy) >= 2.02
Requires: perl(Pod::Usage) >= 1.10
Requires: perl(HTML::Parser) >= 3.43
Requires: perl(Archive::Tar) >= 1.23
Requires: perl(Mail::DKIM) >= 0.37
Requires: perl(Net::DNS) >= 0.58
Requires: perl(NetAddr::IP)
Requires: perl(Sys::Hostname)
Requires: perl(Time::HiRes)
Requires: perl(Time::Local)
Requires: perl(Errno)
#
Requires: perl(MIME::Base64)
Requires: perl(DB_File)
Requires: perl(Net::SMTP)
Requires: perl(Mail::SPF)
Requires: perl(IP::Country::Fast)
Requires: perl(Razor2::Client::Version) >= 2.61
Requires: perl(Net::Ident)
Requires: perl(IO::Socket::INET6)
Requires: perl(IO::Socket::SSL)
Requires: perl(Compress::Zlib)
Requires: perl(DBI)
#Requires: perl(DBD::...)
Requires: perl(Getopt::Long) >= 2.34
Requires: perl(LWP), perl(LWP::UserAgent)
Requires: perl(HTTP::Date)
Requires: perl(IO::Zlib) >= 1.04
Requires: perl(Encode::Detect)
#
Requires: perl(Apache::Test)
Requires: mod_perl
###

Requires: perl(Getopt::Long) >= 2.34
Requires: %{_bindir}/dccproc
Requires: %{_bindir}/pyzor

Requires: procmail
Requires: gnupg

Obsoletes: perl-Mail-SpamAssassin <= %{eversion}

%description
SpamAssassin provides you with a way to reduce if not completely eliminate
Unsolicited Commercial Email (SPAM) from your incoming email.  It can
be invoked by a MDA such as sendmail or postfix, or can be called from
a procmail script, .forward file, etc.  It uses a genetic-algorithm
evolved scoring system to identify messages which look spammy, then
adds headers to the message so they can be filtered by the user's mail
reading software.  This distribution includes the spamd/spamc components
which create a server that considerably speeds processing of mail.

To enable spamassassin, if you are receiving mail locally, simply add
this line to your ~/.procmailrc:
INCLUDERC=%{_sysconfdir}/mail/spamassassin/spamassassin-default.rc

To filter spam for all users, add that line to /etc/procmailrc
(creating if necessary).

%prep
%setup -q -n %{pkgname}-%{version}
%patch0 -p1 -b .krb5

%build
(cd spamc; autoconf)
%define _perl_buildroot %{nil}
test -z "$PERL5LIB" && export PERL5LIB=%{buildroot}%{perl_vendorarch}:%{buildroot}%{perl_vendorlib} || \
  export PERL5LIB="$PERL5LIB":%{buildroot}%{perl_vendorarch}:%{buildroot}%{perl_vendorlib}
test -z "$CFLAGS" && export CFLAGS="%{optflags}"
%{__perl} Makefile.PL 'PREFIX=%{_perl_buildroot}%{_prefix}' INSTALLDIRS=vendor ENABLE_SSL=yes
%{__perl} -pi -e 's/^\tLD_RUN_PATH=[^\s]+\s*/\t/' Makefile
%{__make} OPTIMIZE="$RPM_OPT_FLAGS"
%if %{?_without_check:0}%{!?_without_check:1}
%{__make} test || :
%endif
mv spamd/README spamd/README.spamd

%install
rm -rf %{buildroot}
%{__make} install DESTDIR_REDIRECT=%{buildroot} DESTDIR=%{buildroot}
find %{buildroot} \( -name .packlist -or -name perllocal.pod -or \( -name '*.bs' -a -empty \) \) -exec rm -f {} \;
install -d %{buildroot}/%{_initrddir}
install -p -m 0755 spamd/redhat-rc-script.sh %{buildroot}/%{_initrddir}/spamassassin

mkdir -p %{buildroot}%{_sysconfdir}/mail/spamassassin
mkdir -p -m 0700 %{buildroot}%{_sysconfdir}/mail/spamassassin/sa-update-keys
mkdir -p %{buildroot}%{_sysconfdir}/sysconfig
mkdir -p %{buildroot}%{_sysconfdir}/logrotate.d
mkdir -p %{buildroot}%{_sysconfdir}/cron.daily
install -p -m 0644 %{SOURCE2} %{buildroot}%{_sysconfdir}/mail/spamassassin/local.cf
install -p -m 0644 %{SOURCE5} %{buildroot}%{_sysconfdir}/sysconfig/spamassassin

install -p -m 0644 %{SOURCE3} %{buildroot}%{_sysconfdir}/mail/spamassassin
install -p -m 0644 %{SOURCE4} %{buildroot}%{_sysconfdir}/mail/spamassassin
install -p -m 0755 %{SOURCE10} %{buildroot}%{_sysconfdir}/mail/spamassassin
install -p -m 0644 %{SOURCE6} %{buildroot}/etc/logrotate.d/sa-update
install -p -m 0644 %{SOURCE89} %{SOURCE90} %{buildroot}%{_sysconfdir}/mail/spamassassin
sed -e's,@configdir@,%{_sysconfdir}/mail/spamassassin,g' \
    -e's,@homedir@,/var/lib/spamassassin,g' \
    -e's,@logdir@,/var/log/sa-update.log,g' \
  < %{SOURCE88} > %{buildroot}/etc/cron.daily/sa_update
chmod 0755 %{buildroot}/etc/cron.daily/sa_update
touch -r %{SOURCE88} %{buildroot}/etc/cron.daily/sa_update

pushd %{buildroot}%{_datadir}/spamassassin/
gunzip -c %{SOURCE1} | tar xf -
popd

install -p -m 0644 %{SOURCE20} %{buildroot}%{_datadir}/spamassassin/99_bogus-virus-warnings.cf

install -p -m 0644 %{SOURCE60} %{buildroot}%{_datadir}/spamassassin/sought.rules.yerp.org-key.txt
install -p -m 0644 %{SOURCE50} %{buildroot}%{_datadir}/spamassassin/release-spamassassin.org-key.txt
install -p -m 0644 %{SOURCE40} %{buildroot}%{_datadir}/spamassassin/updates.spamassassin.org-key.txt
#install -p -m 0644 %{SOURCE30} %{buildroot}%{_datadir}/spamassassin/saupdates.openprotect.com-key.txt

mkdir -p %{buildroot}/var/lib/spamassassin

%files
%defattr(-,root,root,-)
%doc README Changes sample-nonspam.txt sample-spam.txt spamd/README.spamd
%doc UPGRADE LICENSE TRADEMARK NOTICE USAGE CREDITS

%{perl_vendorlib}/Mail/SpamAssassin.pm
%{perl_vendorlib}/Mail/SpamAssassin
%{_mandir}/man3/Mail::SpamAssassin*.3pm*
%{_mandir}/man1/sa-awl.1*
%{perl_vendorlib}/spamassassin-run.pod
%{_datadir}/spamassassin

%{_bindir}/sa-learn
%{_bindir}/spamassassin
%{_bindir}/sa-update
%{_bindir}/sa-compile
%{_bindir}/sa-awl
%{_bindir}/sa-check_spamd
%{_mandir}/man1/sa-learn.1*
%{_mandir}/man1/sa-update.1*
%{_mandir}/man1/spamassassin*.1*
%{_mandir}/man1/sa-compile.1*
%{_mandir}/man3/spamassassin-run.3pm*
%config(noreplace) %{_sysconfdir}/mail/spamassassin
%config(noreplace) %{_sysconfdir}/sysconfig/spamassassin
%{_sysconfdir}/cron.daily/sa_update
/var/lib/spamassassin
%{_sysconfdir}/logrotate.d/sa-update

%{_bindir}/spamd
%{_mandir}/man1/spamd.1*
%{_initrddir}/spamassassin

%{_bindir}/spamc
%{_mandir}/man1/spamc.1*

%clean
rm -rf %{buildroot}

%post
/sbin/chkconfig --add spamassassin

for old in /etc/spamassassin.cf /etc/mail/spamassassin.cf; do
  mv $old %{_sysconfdir}/mail/spamassassin/migrated.cf > /dev/null 2>&1 || :
done

# Make sure we import all keys. The release key is not currently
# intended for sa-update functionality, but one is better equipped to
# handle such cases in future upgrades.
sa-update --import %{_datadir}/spamassassin/release-spamassassin.org-key.txt
sa-update --import %{_datadir}/spamassassin/updates.spamassassin.org-key.txt
#sa-update --import %{_datadir}/spamassassin/saupdates.openprotect.com-key.txt
sa-update --import %{_datadir}/spamassassin/sought.rules.yerp.org-key.txt

%postun
if [ "$1" -ge "1" ]; then
    /sbin/service spamassassin condrestart > /dev/null 2>&1
fi

%preun
if [ $1 = 0 ] ; then
    /sbin/service spamassassin stop >/dev/null 2>&1
    /sbin/chkconfig --del spamassassin
fi
exit 0

%changelog
* Wed Dec 12 2018 John Crisp <jcrisp@safeandsoundit.co.uk> 3.4.2-1.sme
- update to 3.4.2 [SME: 10597

* Tue Jun 19 2018 Jean-Philipe Pialasse <tests@pialasse.com> 3.4.1-2.sme
- add build require perl(Net::DNS::Nameserver)  and import dependencies [SME: 10597]

* Wed Jan 6 2016 Daniel Berteaud <daniel@firewall-services.com> - 3.4.1-1.sme
- Update to 3.4.1 [SME: 9153]

* Fri Jul 10 2015 Daniel Berteaud <daniel@firewall-services.com> - 3.3.2-60.sme
- Expand atrpms macro and remove BuildReq on atrpms-rpm-config [SME: 8980]

* Fri Jul 10 2015 Daniel Berteaud <daniel@firewall-services.com> - 3.3.2-59.sme
- Add atrpms-rpm-config to the BUildReq so it can build [SME: 8980]

* Thu Jul 9 2015 Daniel Berteaud <daniel@firewall-services.com> - 3.3.2-58.sme
- Update RegistrarBoundaries.pm to the one from 3.4.1 so URIBL tests are
  done on new tld [SME: 8980] 

* Thu Jul 9 2015 Daniel Berteaud <daniel@firewall-services.com> - 3.3.2-57.sme
- Remove dependency on atrpms macros [SME: 8980]

* Mon Jun 10 2013 Axel Thimm <Axel.Thimm@ATrpms.net> - 
- Update to 3.3.2.

* Fri Nov 26 2010 Axel Thimm <Axel.Thimm@ATrpms.net> - 
- Update to interim dev release 3.3.1_01.

* Thu Nov 25 2010 Axel Thimm <Axel.Thimm@ATrpms.net>
- Remove goto invocations to please perl 5.12.x.

* Fri Jan 29 2010 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 3.3.0 final.

* Mon Dec 28 2009 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 3.3.0 rc1.

* Sun Jun 15 2008 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update spamassassin update key with the cross-signed one.

* Thu Jun 12 2008 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 3.2.5.

* Sat Dec 22 2007 Axel Thimm <Axel.Thimm@ATrpms.net>
- Fix handling of gpgkeys (Jeffrey J. Kosowsky <atrpms@kosowsky.org>).
- channels and gpgkeys are not anymore hardcoded in cron scripts.
- Many smaller cleanups.

* Fri Aug 10 2007 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 3.2.3.
- Remove patches for suid bug (are now upstream).

* Tue Jul 31 2007 Axel Thimm <Axel.Thimm@ATrpms.net>
- Fix pyzor/dcc suid bug.

* Wed Jul 25 2007 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 3.2.2.

* Tue Jun 12 2007 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 3.2.1.
- Rename %{_sysconfdir}/cron.daily/sa-update sa_update to avoid
  conflict with mailscanner project.

* Sat May  5 2007 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 3.2.0.
- Sync with rawhide's sa-update cron.

* Thu Feb 15 2007 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 3.1.8.

* Wed Oct 11 2006 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 3.1.7.

* Fri Oct  6 2006 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 3.1.6.

* Wed Aug 30 2006 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 3.1.5.

* Fri Jul 28 2006 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 3.1.4.

* Wed Jun  7 2006 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 3.1.3.

* Fri May 26 2006 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 3.1.2.

* Sun Mar 12 2006 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 3.1.1.

* Thu Sep 15 2005 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 3.1.0.

* Thu Jun  9 2005 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 3.0.4.

* Fri Apr 29 2005 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 3.0.3.

* Fri Dec 17 2004 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 3.0.2.

* Tue Dec 14 2004 Axel Thimm <Axel.Thimm@ATrpms.net>
- Add support for collateral spam.

* Sat Oct 23 2004 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 3.0.1.

* Wed Sep 22 2004 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 3.0.0 final.

* Fri Sep 17 2004 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 3.0.0-rc5.

* Thu Aug  5 2004 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 3.0.0-pre4.

* Thu Jul 29 2004 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 3.0.0-pre3.

* Thu Jan 22 2004 Axel Thimm <Axel.Thimm@ATrpms.net> 
- Update to 2.63.

* Mon Jan 19 2004 Axel Thimm <Axel.Thimm@ATrpms.net> 
- Update to 2.62.

* Mon Jan 12 2004 Axel Thimm <Axel.Thimm@ATrpms.net>
- Sync with rawhide (remove servicename patch).

* Tue Dec  9 2003 Axel Thimm <Axel.Thimm@ATrpms.net> 
- Upgrade to 2.61.

* Wed Sep 24 2003 Axel Thimm <Axel.Thimm@ATrpms.net> 
- Upgrade to 2.60.
- Sync with rawhide.

* Sat Jul  5 2003 Chip Turner <cturner@redhat.com> 2.55-3
- change perl dependency to more accurate versions with explicit epochs

* Wed Apr 16 2003 Chip Turner <cturner@redhat.com> 2.53-5
- remove SIGCHILD patch to properly return it to SIG_IGN now that
  waitpid isn't used on Linux

* Mon Apr 14 2003 Chip Turner <cturner@redhat.com> 2.53-4.8.x
- update to 2.53 from upstream

* Fri Mar 21 2003 Chip Turner <cturner@redhat.com> 2.50-3.8.x
- update patch for servicename; should fix restarting/runlevel issues (#85975)

* Thu Mar 13 2003 Chip Turner <cturner@redhat.com> 2.50-2.8.x
- update to 2.50

* Tue Feb 25 2003 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Fri Feb 21 2003 Chip Turner <cturner@redhat.com>
- revert double fix for 84774

* Mon Feb 17 2003 Bill Nottingham <notting@redhat.com>
- fix startup (#84445)

* Thu Feb 13 2003 Bill Nottingham <notting@redhat.com>
- fix paths in initscript (#84216)

* Thu Feb 13 2003 Chip Turner <cturner@redhat.com>
- removing -P option since it is the default now, bug 84144

* Wed Feb 12 2003 Florian La Roche <Florian.LaRoche@redhat.de>
- fix SIGCHLD handling

* Mon Feb 10 2003 Bill Nottingham <notting@redhat.com>
- move condrestart to %%postun

* Sun Feb  2 2003 Chip Turner <cturner@redhat.com>
- update to 2.44
- add condrestart to service script

* Thu Jan 30 2003 Chip Turner <cturner@redhat.com>
- release bump and rebuild

* Wed Jan 29 2003 Chip Turner <cturner@redhat.com>
- add upstream bsmtp off-by-one patch

* Mon Jan 20 2003 Chip Turner <cturner@redhat.com>
- add wrapper for 'spamassassin -e' for native evolution spam filtering

* Sat Jan  4 2003 Jeff Johnson <jbj@redhat.com> 2.43-10
- use internal dep generator.

* Wed Jan  1 2003 Chip Turner <cturner@redhat.com>
- rebuild

* Tue Dec 17 2002 Bill Nottingham <notting@redhat.com> 2.43-7
- don't run by default

* Sat Dec 14 2002 Tim Powers <timp@redhat.com> 2.43-6
- don't use rpms internal dep generator
- buildrequire perl-Time-HiRes instead of perl(Time:HiRes) so we can satisfy build deps in the build system

* Fri Nov 22 2002 Tim Powers <timp@redhat.com>
- rebuilt to solve broken perl deps

* Thu Aug 15 2002 Chip Turner <cturner@redhat.com>
- speedup patch from upstream

* Tue Aug  6 2002 Chip Turner <cturner@redhat.com>
- automated release bump and build

* Thu Jul 18 2002 Chip Turner <cturner@redhat.com>
- better control of service level, improvement in %%post script.
- (contribs from schirmer@taytron.net)

* Fri Jun 28 2002 Chip Turner <cturner@redhat.com>
- added proper BuildRequire

* Wed Jun 26 2002 Chip Turner <cturner@redhat.com>
- updated to 2.31, added .rc file for procmail to INCLUDERC to enable

* Fri Apr 19 2002 Theo Van Dinter <felicity@kluge.net>
- Updated for 2.20 release
- made /etc/mail/spamassassin a config directory so local.cf doesn't get wiped out
- added a patch to remove findbin stuff

* Wed Feb 27 2002 Craig Hughes <craig@hughes-family.org>
- Updated for 2.1 release

* Sat Feb 02 2002 Theo Van Dinter <felicity@kluge.net>
- Updates for 2.01 release
- Fixed rc file
- RPM now buildable as non-root
- fixed post_service errors
- fixed provides to include perl modules
- use file find instead of manually specifying files

* Tue Jan 15 2002 Craig Hughes <craig@hughes-family.org>
- Updated for 2.0 release

* Wed Dec 05 2001 Craig Hughes <craig@hughes-family.org>
- Updated for final 1.5 distribution.

* Sun Nov 18 2001 Craig Hughes <craig@hughes-family.org>
- first version of rpm.

